<?php
namespace Emblz\SendTrackNumbers\Model;

use Emblz\SendTrackNumbers\Helper\Data;
use Magento\Framework\App\Helper\Context;
use Magento\Framework\ObjectManagerInterface;

class SendTrackHandler
{
    /**
     * @var Data
     */
    protected $helper;

    /**
     * @var \Psr\Log\LoggerInterface
     */
    protected $logger;

    public function __construct(
        ObjectManagerInterface $objectManager,
        Context $context
    )
    {
        $this->helper = $objectManager->get("\Emblz\SendTrackNumbers\Helper\Data");
        $this->logger = $context->getLogger();
    }

    /**
     * @param string $message
     * @return string
     */
    public function process($message)
    {
        $this->logger->info("Received message for sending track");
        $data = json_decode($message, true);
        $trackId = $data["trackId"];
        $this->logger->info("About to handle trackId: " . $trackId);
        $orderId = $data["orderId"];
        $storeId = $data["storeId"];
        $trackData = $data["data"];
        $this->helper->sendTrack($trackData, $storeId, $trackId, $orderId);
        return $trackId . ' processed by SendTrackerHandler';
    }
}
